/***************************************************************************
 *   Copyright (C) 2006 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TEXTFILTER_H
#define TEXTFILTER_H

#include <honokapluginbase.h>
#include <resultlist.h>

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <scim.h>
#include <scim_iconv.h>
#include <scim_attribute.h>

#include <convertor.h>


using namespace std;
using namespace scim;

namespace Honoka {

/**
	@author TAM (Teppei Tamra) <tam-t@par.odn.ne.jp>
*/
class TextFilter : public HonokaPluginBase {
public:
    TextFilter(ConfigPointer cfg);

    ~TextFilter();
    virtual void unSelected();
    virtual void selected();
    virtual String getName();
    virtual String getPropertyName();
    virtual const WideString filter(const WideString &text);
    virtual const WideString filter(vector<Segment> segments);
protected:
    ConfigPointer config;
};

}
#endif
